/*!
 * @file startup.s
 * @brief this file contains startup code
 */
 
    .text	
	.set vector_base,	_vector_table
	.set rvbar_base,	0xFD5C0040
	.set EL3_stack,	top_of_stacks

	.section ".entry","ax"
    .global Reset_Handler
    .func Reset_Handler
/*	.fpu neon	*/
	
Reset_Handler:
    mov      x0, #0
	mov      x1, #0
	mov      x2, #0
	mov      x3, #0
	mov      x4, #0
	mov      x5, #0
	mov      x6, #0
	mov      x7, #0
	mov      x8, #0
	mov      x9, #0
	mov      x10, #0
	mov      x11, #0
	mov      x12, #0
	mov      x13, #0
	mov      x14, #0
	mov      x15, #0
	mov      x16, #0
	mov      x17, #0
	mov      x18, #0
	mov      x19, #0
	mov      x20, #0
	mov      x21, #0
	mov      x22, #0
	mov      x23, #0
	mov      x24, #0
	mov      x25, #0
	mov      x26, #0
	mov      x27, #0
	mov      x28, #0
	mov      x29, #0
	mov      x30, #0
	
	mrs      x0, MPIDR_EL1				// Access Multiprocessor Affinity Register
	and      x0, x0, #0xFF              // Mask off to leave Aff0(Aff lvl0).Indicates the core number in the processor
	cbz      x0, primary_cpu_init		// If core 0, run the primary init code
1:	B     1b							// Hold if not core 0
	
primary_cpu_init:

	/*Set vector table base address*/
	ldr	x1, =vector_base
	msr	VBAR_EL3,x1

	/* Set reset vector address */
	/* Get the cpu ID */
	mrs  x0, MPIDR_EL1
	and  x0, x0, #0xFF
	mov  w0, w0

	ldr	 w2, =rvbar_base
	/* calculate the rvbar base address for particular CPU core */
	mov	 w3, #0x8
	mul	 w0, w0, w3
	add	 w2, w2, w0
	/* store vector base address to RVBAR */
	str  x1, [x2]

	/*Define stack pointer for current exception level*/
	ldr	 x2,=EL3_stack
	mov	 sp,x2

	/* clear sbss */
	mov	x0, #0
	ldr 	w1,__bss_start__		/* calculate beginning of the BSS */
	ldr	w2,__bss_end__		/* calculate end of the BSS */
	uxtw	x1, w1			/*zero extension to w1 register*/
	uxtw	x2, w2			/*zero extension to w2 register*/
.loop_bss:
	cmp	x1,x2
	bge	.brkbss		/* If no BSS, no clearing required */
	str	x0, [x1], #8		/* Store x0 to address in x1 and increment x1 by 8 */
	b	.loop_bss
.brkbss:
1:
        b       1b

    .endfunc
	
