.ORG 0
.text

.global Reset_Handler
.global _vector_table
.global _irq_handler
.section .vector, "a" 

_vector_table:
.set	VBAR, _vector_table
.org VBAR
	b	Reset_Handler
.org (VBAR + 0x80)
	b	_irq_handler
.org (VBAR + 0x100)
	b	.
.org (VBAR + 0x180)
	b	.
.org (VBAR + 0x200)
	b	.
.org (VBAR + 0x280)
	b	_irq_handler
.org (VBAR + 0x300)
	b	.
.org (VBAR + 0x380)
	b	.
.org (VBAR + 0x400)
	b	.
.org (VBAR + 0x480)
	b	_irq_handler
.org (VBAR + 0x500)
	b	.
.org (VBAR + 0x580)
	b	.
.org (VBAR + 0x600)
	b	.
.org (VBAR + 0x680)
	b	.
.org (VBAR + 0x700)
	b	.
.org (VBAR + 0x780)
	b	.	


_irq_handler:
	stp	X0,X1, [sp,#-0x10]!
	stp	X2,X3, [sp,#-0x10]!
	stp	X4,X5, [sp,#-0x10]!
	stp	X6,X7, [sp,#-0x10]!
	stp	X8,X9, [sp,#-0x10]!
	stp	X10,X11, [sp,#-0x10]!
	stp	X12,X13, [sp,#-0x10]!
	stp	X14,X15, [sp,#-0x10]!
	stp	X16,X17, [sp,#-0x10]!
	stp     X18,X19, [sp,#-0x10]!
	stp     X29,X30, [sp,#-0x10]!

	bl      IRQ_HLDR

	ldp     X29,X30, [sp], #0x10
	ldp     X18,X19, [sp], #0x10
	ldp	X16,X17, [sp], #0x10
	ldp	X14,X15, [sp], #0x10
	ldp	X12,X13, [sp], #0x10
	ldp	X10,X11, [sp], #0x10
	ldp	X8,X9, [sp], #0x10
	ldp	X6,X7, [sp], #0x10
	ldp	X4,X5, [sp], #0x10
	ldp	X2,X3, [sp], #0x10
	ldp	X0,X1, [sp], #0x10

	eret
	
IRQ_HLDR:	
	eret